%define anolis_release 1
%bcond_without bpf

Name:           v4l-utils
Version:        1.26.1
Release:        %{anolis_release}%{?dist}
Summary:        Utilities for video4linux and DVB devices
License:        GPLv2+ and GPLv2
URL:            http://www.linuxtv.org/downloads/v4l-utils/
Source0:        http://linuxtv.org/downloads/v4l-utils/v4l-utils-%{version}.tar.xz
Patch1:         0001-utils-v4l2-TPG-Update-use-of-typeof.patch

BuildRequires:  kernel-headers systemd
BuildRequires:  alsa-lib-devel desktop-file-utils qt5-qtbase-devel json-c-devel
BuildRequires:  doxygen gettext systemd-devel meson >= 0.56 libjpeg-devel

%if %{with bpf}
BuildRequires:  elfutils-libelf-devel clang libbpf-devel
%endif

Requires:       systemd-udev libv4l = %{EVR}

%description
Linux utilities and libraries to handle media devices (TV devices, capture
devices, radio devices, remote controllers).

%package        doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%package        devel-tools
Summary:        Utilities for v4l2 / DVB driver development and debugging
License:        GPLv2+ and GPLv2
Requires:       libv4l = %{EVR}

%description    devel-tools
Utilities for v4l2 / DVB driver authors: decode_tm6000, v4l2-compliance and
v4l2-dbg.

%package -n     qv4l2
Summary:        QT v4l2 test control and streaming test application
License:        GPLv2+
Requires:       libv4l = %{EVR}

%description -n qv4l2
QT v4l2 test control and streaming test application.

%package -n     libv4l
Summary:        Collection of video4linux support libraries
License:        LGPLv2+ and GPLv2
URL:            http://hansdegoede.livejournal.com/3636.html

%description -n libv4l
libv4l is a collection of libraries which adds a thin abstraction layer on
top of video4linux2 devices. The purpose of this (thin) layer is to make it
easy for application writers to support a wide variety of devices without
having to write separate code for different devices in the same class. libv4l
consists of 3 different libraries: libv4lconvert, libv4l1 and libv4l2.

%package -n     libdvbv5
Summary:        Libraries to control, scan and zap on Digital TV channels
License:        GPLv2

%description -n libdvbv5
This library is meant to be used by digital TV applications that need to talk
with media hardware.

%package -n     libv4l-devel
Summary:        Development files for libv4l
License:        LGPLv2+
URL:            http://hansdegoede.livejournal.com/3636.html
Requires:       libv4l = %{EVR}

%description -n libv4l-devel
This package provides libraries and header files for developing applications
that use libv4l.

%package -n     libdvbv5-devel
Summary:        Development files for libdvbv5
License:        GPLv2
Requires:       libdvbv5 = %{EVR}

%description -n libdvbv5-devel
This package provides libraries and header files for developing applications
that use libdvbv5.

%prep
%autosetup -p1
sed -i "/subdir('bpf_protocols')/d" utils/keytable/meson.build

%build
%meson -Dbpf=auto -Ddoxygen-man=true -Ddoxygen-html=false
%meson_build

%install
%meson_install

find %{buildroot} -name '*.la' -delete
rm -f %{buildroot}%{_libdir}/{v4l1compat.so,v4l2convert.so}
mkdir $RPM_BUILD_ROOT%{_libdir}/gconv/gconv-modules.d
mv $RPM_BUILD_ROOT%{_libdir}/gconv/gconv-modules $RPM_BUILD_ROOT%{_libdir}/gconv/gconv-modules.d/libdvbv5.conf
desktop-file-validate %{buildroot}%{_datadir}/applications/qv4l2.desktop
%find_lang %{name}
%find_lang libdvbv5

%generate_compatibility_deps

%files -f %{name}.lang
%dir %{_sysconfdir}/rc_keymaps
%config(noreplace) %{_sysconfdir}/rc_maps.cfg
%{_udevrulesdir}/70-infrared.rules
%{_udevrulesdir}/../rc_keymaps/*

%{_bindir}/cx18-ctl
%{_bindir}/cec-compliance
%{_bindir}/cec-ctl
%{_bindir}/cec-follower
%{_bindir}/dvb-fe-tool
%{_bindir}/dvb-format-convert
%{_bindir}/dvbv5-daemon
%{_bindir}/dvbv5-scan
%{_bindir}/dvbv5-zap
%{_bindir}/ir-ctl
%{_bindir}/ir-keytable
%{_bindir}/ivtv-ctl
%{_bindir}/media-ctl
%{_bindir}/rds-ctl
%{_bindir}/v4l2-ctl
%{_bindir}/v4l2-sysfs-path
%{_bindir}/v4l2-tracer
%{_libdir}/gconv/*.so
%{_libdir}/gconv/gconv-modules.d/libdvbv5.conf

%dir %{abidir}
%{abidir}/cx18-ctl-option.list
%{abidir}/cec-compliance-option.list
%{abidir}/cec-ctl-option.list
%{abidir}/cec-follower-option.list
%{abidir}/dvb-fe-tool-option.list
%{abidir}/dvb-format-convert-option.list
%{abidir}/dvbv5-daemon-option.list
%{abidir}/dvbv5-scan-option.list
%{abidir}/dvbv5-zap-option.list
%{abidir}/ir-ctl-option.list
%{abidir}/ir-keytable-option.list
%{abidir}/ivtv-ctl-option.list
%{abidir}/media-ctl-option.list
%{abidir}/rds-ctl-option.list
%{abidir}/v4l2-ctl-option.list
%{abidir}/v4l2-sysfs-path-option.list
%{abidir}/ARIB-STD-B24.dump
%{abidir}/EN300-468-TAB00.dump
%{abidir}/v4l2-tracer-option.list

%{_mandir}/man1/*.1*
%{_mandir}/man5/*.5*
%exclude %{_mandir}/man1/qv4l2.1*
%exclude %{_mandir}/man1/v4l2-compliance.1*

%files devel-tools
%{_bindir}/decode_tm6000
%{_bindir}/v4l2-compliance
%{_sbindir}/v4l2-dbg

%{abidir}/decode_tm6000-option.list
%{abidir}/v4l2-dbg-option.list
%{_mandir}/man1/v4l2-compliance.1*

%files doc
%doc README.*
%doc ChangeLog TODO

%files -n qv4l2
%{_bindir}/qv4l2
%{_bindir}/qvidcap
%{_datadir}/applications/qv4l2.desktop
%{_datadir}/applications/qvidcap.desktop
%{_datadir}/icons/hicolor/*/apps/qv4l2.*
%{_datadir}/icons/hicolor/*/apps/qvidcap.*
%{_mandir}/man1/qv4l2.1*
%{_mandir}/man1/qvidcap.1*

%files -n libv4l
%{_libdir}/libv4l
%{_libdir}/libv4l1.so.0
%{_libdir}/libv4l1.so.0.0.0
%{_libdir}/libv4l2.so.0
%{_libdir}/libv4l2.so.0.0.0
%{_libdir}/libv4l2rds.so.0
%{_libdir}/libv4l2rds.so.0.0.0
%{_libdir}/libv4lconvert.so.0
%{_libdir}/libv4lconvert.so.0.0.0
%{abidir}/libv4l*.dump
%{abidir}/v4l1compat.dump
%{abidir}/v4l2convert.dump
%license COPYING.libv4l COPYING

%files -n libv4l-devel
%{_includedir}/libv4l*.h
%{_libdir}/libv4l*.so
%{_libdir}/pkgconfig/libv4l*.pc

%files -n libdvbv5 -f libdvbv5.lang
%{_libdir}/libdvbv5.so.0
%{_libdir}/libdvbv5.so.0.0.0
%{abidir}/libdvbv5*.dump
%license COPYING

%files -n libdvbv5-devel
%{_libdir}/libdvbv5.so
%{_libdir}/pkgconfig/libdvbv5.pc
%{_includedir}/libdvbv5/*.h
%{_mandir}/man3/*.3*

%changelog
* Fri Mar 21 2025 mgb01105731 <mgb01105731@alibaba-inc.com> - 1.26.1-1
- Update to 1.26.1 from 1.24.1
- switch to build using meson

* Fri Apr 14 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 1.24.1-2
- Refactor the specfile

* Sat Mar 04 2023 Shawn Wang <shawnwang@linux.alibaba.com> - 1.24.1-1
- update to 1.24.1

* Thu Apr 14 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1.22.1-1
- init from upstream
